
' $DYNAMIC

DEFINT A-Z

TYPE ObjType
   XSize AS INTEGER
   YSize AS INTEGER
   p AS INTEGER
   X AS INTEGER
   Y AS INTEGER
   DX AS INTEGER
   DY AS INTEGER
   Damage AS INTEGER
   g AS INTEGER
END TYPE

TYPE Colour
   Red AS INTEGER
   Green AS INTEGER
   Blue AS INTEGER
END TYPE

DECLARE SUB Init ()
DECLARE SUB InitStars ()
DECLARE SUB NewStar (n AS INTEGER)
DECLARE SUB NewExpl (X AS INTEGER, Y AS INTEGER, S AS INTEGER, t AS INTEGER, u AS INTEGER)
DECLARE SUB CYaL8r ()
DECLARE SUB Intro1 ()
DECLARE SUB Intro2 ()
DECLARE SUB Intro3 ()
DECLARE SUB EndScene1 ()
DECLARE SUB EndScene2 ()
DECLARE SUB EndScene3 ()
DECLARE FUNCTION TitleScreen ()
DECLARE SUB Instructions ()
DECLARE SUB GameInfo ()
DECLARE SUB HiScore (Score AS LONG)
DECLARE SUB DispHiScores ()
DECLARE SUB GetPics ()
DECLARE SUB SetPalette (PalArray() AS Colour, c1 AS INTEGER, c2 AS INTEGER)
DECLARE SUB ChangePalette (n AS INTEGER, c1 AS INTEGER, c2 AS INTEGER)
DECLARE SUB SetLocks (n AS INTEGER)
DECLARE SUB Text (Batch AS INTEGER, x1 AS INTEGER, y1 AS INTEGER, x2 AS INTEGER, y2 AS INTEGER, Message AS STRING, Col AS INTEGER)
DECLARE SUB TitlePal ()
DECLARE SUB RotateFontPal (Batch AS INTEGER)
DECLARE SUB MoveStars (BGCol AS INTEGER, cud AS INTEGER)
DECLARE SUB MoveStars2 ()
DECLARE SUB MoveExpl (n AS INTEGER)
DECLARE SUB VPutDBL (x1 AS INTEGER, y1 AS INTEGER, A() AS DOUBLE, el AS LONG, Mode, MinY AS INTEGER, MaxY AS INTEGER)

CONST MaxExpl = 32
CONST Pi = 3.141593

OPTION BASE 0

DIM SHARED IntScr AS INTEGER

DIM SHARED FontPal(1 TO 20, 1 TO 4) AS INTEGER
DIM SHARED Pal(0 TO 255) AS Colour

DIM SHARED FontWidth(95) AS INTEGER

DIM SHARED Stars(1 TO 200) AS ObjType
DIM SHARED NumStars AS INTEGER

DIM SHARED PC AS INTEGER
DIM SHARED Fl1 AS INTEGER
DIM SHARED Ex1 AS INTEGER ' exit status
DIM SHARED OldLocks AS INTEGER ' original status of caps, scroll, num locks
DIM SHARED OP AS INTEGER ' old PEEK(284)
DIM SHARED FadeDat(1 TO 25) AS INTEGER
DIM SHARED FontPC(0 TO 2) AS INTEGER ' font palette counter
DIM SHARED FontCol(0 TO 2) AS Colour ' current font colour -- 1 to 7
'                             1 . . . . RED
'                             2 . . . . GREEN
'                             3 . . . . yellow
'                             4 . . . . BLUE
'                             5 . . . . purple
'                             6 . . . . cyan
'                             7 . . . . white

'CHDIR "d:\qb\starfire"

'ON ERROR GOTO ErrorHandler

OPEN "starfire.tmp" FOR RANDOM AS #1 LEN = 20
FIELD #1, 20 AS f$: GET #1, 1
IF f$ <> STRING$(20, 0) THEN ' file exists
   CLOSE #1
   OPEN "starfire.tmp" FOR INPUT AS #1
   INPUT #1, OldLocks, t, l&
   CLOSE #1
   KILL "starfire.tmp"
   Ex1 = 10
ELSE
   CLOSE #1
   Ex1 = 0
END IF


BeginNew:


Init

   DIM SHARED RedCol(160 TO 175) AS Colour
   FOR t1 = 160 TO 175: READ RedCol(t1).Red, RedCol(t1).Green, RedCol(t1).Blue: NEXT t1
   DIM SHARED Int3Pal(1 TO 12) AS LONG
   FOR t1 = 1 TO 12
      READ t2, t3, t4
      Int3Pal(t1) = t2 + t3 * 256 + t4 * 65536
   NEXT t1

Fl1 = 0
IF Ex1 = 0 THEN Intro1
IF Ex1 = 0 THEN Intro2
IF Ex1 = 0 THEN
   DIM SHARED LExplodePics(100 * 4) AS INTEGER ' 14 x 14 = 200 bytes
   DIM SHARED LExplodeMasks(100 * 4)  AS INTEGER
   DIM SHARED BExplodePics(394 * 7)  AS INTEGER ' 14 x 14 = 788 bytes
   DIM SHARED BExplodeMasks(394 * 7)  AS INTEGER
   DEF SEG = VARSEG(LExplodePics(0)): BLOAD "intexpl.qbs", VARPTR(LExplodePics(0))
   DEF SEG = VARSEG(LExplodeMasks(0)): BLOAD "explode.mas", VARPTR(LExplodeMasks(0))
   DEF SEG = VARSEG(BExplodePics(0)): BLOAD "intexpl2.qbs", VARPTR(BExplodePics(0))
   DEF SEG = VARSEG(BExplodeMasks(0)): BLOAD "explode2.mas", VARPTR(BExplodeMasks(0))
   DIM SHARED Expl(1 TO MaxExpl) AS ObjType
   Intro3
   IF Ex1 <> 9 THEN Fl1 = -9
ELSE
   ChangePalette 0, 0, 255
END IF

IF t = -2 THEN
   DIM FontPics(34 * 96 * 3) AS INTEGER' 8 x 8 = 68 bytes
   DEF SEG = VARSEG(FontPics(0)): BLOAD "font.qbs", VARPTR(FontPics(0))

   DIM SHARED LExplodePics(100 * 4) AS INTEGER ' 14 x 14 = 200 bytes
   DIM SHARED LExplodeMasks(100 * 4)  AS INTEGER
   DIM SHARED BExplodePics(394 * 7)  AS INTEGER ' 14 x 14 = 788 bytes
   DIM SHARED BExplodeMasks(394 * 7)  AS INTEGER
   DEF SEG = VARSEG(LExplodePics(0)): BLOAD "intexpl.qbs", VARPTR(LExplodePics(0))
   DEF SEG = VARSEG(LExplodeMasks(0)): BLOAD "explode.mas", VARPTR(LExplodeMasks(0))
   DEF SEG = VARSEG(BExplodePics(0)): BLOAD "intexpl2.qbs", VARPTR(BExplodePics(0))
   DEF SEG = VARSEG(BExplodeMasks(0)): BLOAD "explode2.mas", VARPTR(BExplodeMasks(0))
   DIM SHARED Expl(1 TO MaxExpl) AS ObjType
   EndScene1
   DIM SHARED LasData(1 TO 8, 1 TO 4) AS INTEGER
   RESTORE LasData
   FOR t2 = 1 TO 8: FOR t3 = 1 TO 4
      READ LasData(t2, t3)
   NEXT t3: NEXT t2
   EndScene2
   REDIM SHARED Expl(1 TO MaxExpl) AS ObjType
   DIM SHARED E1(1 TO 4, 1 TO 2) AS INTEGER
   RESTORE ExpPos
   FOR t2 = 1 TO 4: FOR t3 = 1 TO 2
      READ E1(t2, t3)
   NEXT t3: NEXT t2
   EndScene3
   ChangePalette 0, 0, 255
END IF


REDIM SHARED FontPics(34 * 96 * 3) AS INTEGER ' 8 x 8 = 68 bytes
DIM SHARED ShipPics(202 * 8) AS INTEGER ' 20 x 20 = 404 bytes
DIM SHARED GoodiesPics(52 * 8) AS INTEGER
DIM SHARED Instruct(14) AS STRING

GetPics

Ex1 = 0: IF t < 0 THEN HiScore l&
Ex1 = 0

IntScr = 0

   
   DO
      ChangePalette 0, 32, 47
      t = TitleScreen
      IF t = 2 THEN Instructions
      IF t = 3 THEN GameInfo
      IF t = -1 THEN DispHiScores
   LOOP UNTIL t = 0 OR t = 1

OPEN "starfire.tmp" FOR OUTPUT AS #1
PRINT #1, OldLocks, t, 0
CLOSE #1

WIDTH 80: CLS

CHAIN "starfire"



ErrorHandler:
   SELECT CASE ERR
      CASE 53, 62
         IF Ex1 = -1 THEN
            Ex1 = 0
            RESUME BeginNew
         ELSE
            PRINT "Could not find a game file . . . " '''''''''''
            END
         END IF
      CASE ELSE
         ERROR ERR
   END SELECT
RESUME NEXT

DATA 0,10,20,35,50,65,80,90,100,100
DATA 100,100,100,100,100
DATA 100,100,90,80,65,50,35,20,10,0

DATA 62,21,4, 59,20,4, 56,19,4, 53,18,4, 50,17,4, 47,16,4, 44,15,4, 41,14,4
DATA 38,13,4, 35,12,4, 32,11,4, 29,10,4, 26,9,4, 23,8,4, 20,7,4, 17,6,4

DATA 20,20,20, 40,40,40, 63,63,63
DATA 56,56,56, 49,49,49, 42,42,42
DATA 35,35,35, 28,28,28, 21,21,21, 14,14,14, 7,7,7, 0,0,0

InstrData:

DATA "as you know, our space has been invaded by a powerful enemy, intent on destruction of the human race.  your mission is to enter enemy-occupied space and disable the primary military base they have set up there.  expect to encounter heavy "
DATA "resistance.  recent scans have detected swarms of fighter ships and a number of large assault craft protecting the base.  if you can destroy this base, it may be enough to force the enemy out of our space and end the threat of extermination."

DATA "before you leave on your mission, you should take advantage of the realistic simulators in this facility.  there we will pit you against the enemies we have been able to fully scan.  learn the strengths and weaknesses of each enemy ship, "
DATA "learn which weapons are most effective against them, and learn how to dodge enemy fire.  learn the ways of the enemy well, until you feel you are prepared to leave on your mission."

DATA "your ship is a Starfire class fighter.  it has a modular design, making it easily upgradable.  pick up any power-ups that enemies leave behind to increase the power of your ship.",""

DATA "your initial weapon has unlimited ammunition, but all other weapons will eventually run out.  each pulse cannon, scattergun, and laser power-up you collect will increase the power of that weapon by one level.  "
DATA "there are three levels of power for each weapon."

DATA "devastation bomb power-ups will give you one extra bomb.  devastation bombs are very powerful, and will destroy both enemy ships and their shots.  they will only cause minor damage to assault-sized ships however.",""

DATA "each one of these gives you an extra life.  the more of these you can pick up, the greater your chances of defeating the enemy fleets.",""

DATA "this item enhances the engines on your ship, slightly increasing its maximum sideways speed.  there is no limit to the number of speed boosters you can accumulate.",""

DATA "shields are of vital importance to protect your ship.  shields are weakened when hit by enemy shots. when they run out, your ship is vulnerable to enemy fire.  "
DATA "acquiring a shield booster will increase your shields to maximum strength of your current shield level.  if you are already at maximum strength, your shield level will increase."

DATA "the pulse cannon is the primary weapon on your ship.  it fires a small pulse of energy, its direction depending on the motion of your ship.  higher level pulse cannons fire two shots at once.",""

DATA "scatterguns have a high firing rate, although their direction is somewhat random.  unlike the other weapons, the scattergun is automatic, thus the button can be held down while firing.",""

DATA "this weapon has the capability to slice through a number of enemy ships with a single shot.  it is fast and accurate, and is particularly effective against larger ships.",""

DATA "your ship comes standard with one such bomb, although it has capacity for up to ten.  when fired, these bombs cause massive damage to all enemies within range, also destroying enemy shots.",""

DATA "Starfire is FREEWARE by David Karlov, 1998",""

DATA "for more information, read the file STARFIRE.TXT",""

DATA "if you have any suggestions, comments, questions, etc then email me at:"


'DATA "All parts of this game, including programming, graphics, and sound were made by David Karlov.  The 3d graphics were produced with another of my QB programs, a 3d renderer based on a Pascal program given in Alan Watt's book, "
'DATA "Three-Dimensional Computer Graphics.  All other graphics was made in the highly recommended QBPaint by the S.H. Softworx.  Text routines were made by me.   "

LasData:
DATA 213,157,221,137
DATA 211,155,217,135
DATA 202,146,194,126
DATA 198,145,185,125
DATA 178,135,143,115
DATA 174,133,132,113
DATA 146,123,90,103
DATA 139,121,76,101

ExpPos:
DATA 160,110,148,107,134,104,118,101

REM $STATIC
SUB ChangePalette (n AS INTEGER, c1 AS INTEGER, c2 AS INTEGER) STATIC

SELECT CASE n
   CASE 0 ' title screen palette
      DEF SEG = VARSEG(Pal(0)): BLOAD "title.pal", VARPTR(Pal(0))
   CASE 1 ' default game palette
      DEF SEG = VARSEG(Pal(0)): BLOAD "game.pal", VARPTR(Pal(0))
   CASE 2 ' intro palette 1
      DEF SEG = VARSEG(Pal(0)): BLOAD "intro1.pal", VARPTR(Pal(0))
   CASE 3 ' intro palette 2
      DEF SEG = VARSEG(Pal(0)): BLOAD "intro2.pal", VARPTR(Pal(0))
   CASE 4 ' instructions palette
      DEF SEG = VARSEG(Pal(0)): BLOAD "instruct.pal", VARPTR(Pal(0))
   CASE 5 ' extro palette 2
      DEF SEG = VARSEG(Pal(0)): BLOAD "extro2.pal", VARPTR(Pal(0))

END SELECT
DEF SEG

IF c2 < c1 THEN SWAP c1, c2
SetPalette Pal(), c1, c2: PALETTE 255, 0

END SUB

SUB CYaL8r STATIC

' farewell . . . .

SetLocks 0

SCREEN 0, 0, 0: WIDTH 80: CLS : END


END SUB

SUB DispHiScores

IntScr = 0


DIM HiNames(1 TO 10) AS STRING * 16
DIM HiScores(1 TO 10) AS STRING * 8

   NumStars = 100
   FOR t = 1 TO NumStars
      Stars(t).g = 0
      Stars(t).p = (Stars(t).p MOD 16) + 32
   NEXT t

OPEN "hiscore.dat" FOR INPUT AS #1
FOR t = 1 TO 10
   INPUT #1, HiNames(t), HiScores(t)
NEXT t
CLOSE #1

CLS : ChangePalette 0, 0, 255
Text 0, 54, 10, 0, 0, "name", 1
Text 0, 208, 10, 0, 0, "score", 1
FOR t = 1 TO 10
   sc$ = HiScores(t)
   DO UNTIL LEFT$(sc$, 1) <> "0" OR LEN(sc$) = 1
      sc$ = RIGHT$(sc$, LEN(sc$) - 1)
   LOOP
   Text 1, 54, t * 15 + 15, 0, 0, HiNames(t), 2
   Text 2, 208, t * 15 + 15, 0, 0, sc$, 3
NEXT t

   DO: LOOP UNTIL INKEY$ = ""
   C = 0
   DO
      OP = PEEK(284): DEF SEG
      C = C + 1
      MoveStars 0, 0
 
      RotateFontPal 1
      IF C MOD 2 THEN RotateFontPal 2
      IF C MOD 3 = 0 THEN RotateFontPal 0

      DEF SEG = 53
      DO: LOOP UNTIL PEEK(284) <> OP
   LOOP UNTIL INKEY$ <> "" OR C >= 200

   CLS

END SUB

REM $DYNAMIC
SUB EndScene1

IntScr = 10

DIM PicSize(2 TO 5, 1 TO 40) AS INTEGER   ' size of each image in bytes
                                       ' and elements in a DOUBLE array
                                       ' then x width and y width
                                       ' then where the pic starts in the array

DIM SPicSize(2 TO 5, 1 TO 40) AS INTEGER

OPEN "extro1sh.pic" FOR INPUT AS #1
TPS3& = LOF(1) \ 8: CLOSE #1
DIM Int3(TPS3&) AS DOUBLE
DEF SEG = VARSEG(SPicSize(2, 1)): BLOAD "extro1sh.dat", VARPTR(SPicSize(2, 1))
DEF SEG = VARSEG(Int3(0)): BLOAD "extro1sh.pic", VARPTR(Int3(0))
DEF SEG

TPS1& = 0: TPS2& = 0
OPEN "extro1_1.pic" FOR INPUT AS #1: TPS1& = TPS1& + LOF(1) \ 8: CLOSE #1
OPEN "extro1_2.pic" FOR INPUT AS #1: TPS1& = TPS1& + LOF(1) \ 8: CLOSE #1
OPEN "extro1_3.pic" FOR INPUT AS #1: TPS1& = TPS1& + LOF(1) \ 8: CLOSE #1
OPEN "extro1_4.pic" FOR INPUT AS #1: TPS2& = TPS2& + LOF(1) \ 8: CLOSE #1
OPEN "extro1_5.pic" FOR INPUT AS #1: TPS2& = TPS2& + LOF(1) \ 8: CLOSE #1
OPEN "extro1_6.pic" FOR INPUT AS #1: TPS2& = TPS2& + LOF(1) \ 8: CLOSE #1

DIM Int1(TPS1&) AS DOUBLE
DIM Int2(TPS2&) AS DOUBLE

DEF SEG = VARSEG(PicSize(2, 1)): BLOAD "extro1.dat", VARPTR(PicSize(2, 1))

DEF SEG = VARSEG(Int1(PicSize(5, 1))): BLOAD "extro1_1.pic", VARPTR(Int1(PicSize(5, 1)))
DEF SEG = VARSEG(Int1(PicSize(5, 8))): BLOAD "extro1_2.pic", VARPTR(Int1(PicSize(5, 8)))
DEF SEG = VARSEG(Int1(PicSize(5, 14))): BLOAD "extro1_3.pic", VARPTR(Int1(PicSize(5, 14)))
DEF SEG = VARSEG(Int2(PicSize(5, 21))): BLOAD "extro1_4.pic", VARPTR(Int2(PicSize(5, 21)))
DEF SEG = VARSEG(Int2(PicSize(5, 28))): BLOAD "extro1_5.pic", VARPTR(Int2(PicSize(5, 28)))
DEF SEG = VARSEG(Int2(PicSize(5, 34))): BLOAD "extro1_6.pic", VARPTR(Int2(PicSize(5, 34)))
DEF SEG


CLS

NumStars = 100
FOR t = 1 TO NumStars
   Stars(t).X = INT(RND * 320)
   Stars(t).Y = INT(RND * 200)
   Stars(t).p = INT(RND * 16 + 240)
   Stars(t).DX = 1
   Stars(t).DY = -INT(RND * 2) - 3
NEXT t

ChangePalette 2, 0, 255


x1 = 80
y1 = 90

x2 = 270
y2 = 160

FOR t = 1 TO 40
  
   OP = PEEK(240): DEF SEG
   IF t > 1 THEN
      LINE (x1 - PicSize(3, t - 1) / 2, y1 - PicSize(4, t - 1) / 2)-(x1 + PicSize(3, t - 1) / 2, y1 + PicSize(4, t - 1) / 2), 0, BF
      LINE (x2 - SPicSize(3, t - 1) / 2, y2 - SPicSize(4, t - 1) / 2)-(x2 + SPicSize(3, t - 1) / 2, y2 + SPicSize(4, t - 1) / 2), 0, BF
   END IF
   x1 = x1: y1 = y1
   x2 = x2 - 3: y2 = y2 - (t - 16) / 10
   IF t <= 20 THEN
      PUT (x1 - PicSize(3, t) / 2, y1 - PicSize(4, t) / 2), Int1(PicSize(5, t)), PSET
   ELSE
      PUT (x1 - PicSize(3, t) / 2, y1 - PicSize(4, t) / 2), Int2(PicSize(5, t)), PSET
   END IF
   PUT (x2 - SPicSize(3, t) / 2, y2 - SPicSize(4, t) / 2), Int3(SPicSize(5, t)), PSET
   MoveStars2

   DEF SEG = 53
   DO
      IF INKEY$ <> "" THEN CLS : Ex1 = 9: EXIT SUB
   LOOP UNTIL PEEK(240) <> OP

NEXT t

CLS

ERASE Int1, Int2, Int3, PicSize, SPicSize
PALETTE 0, 0

END SUB

SUB EndScene2

IntScr = 11

DIM PicSize(2 TO 5, 1 TO 50) AS INTEGER
DIM EPicSize(2 TO 5) AS INTEGER

TPS& = 0: TPS2& = 0
OPEN "extro2_1.pic" FOR INPUT AS #1: TPS& = LOF(1) \ 8: CLOSE #1
OPEN "extro2eb.pic" FOR INPUT AS #1: TPS2& = LOF(1) \ 8: CLOSE #1
EPicSize(5) = TPS2&

DIM Int1(TPS&) AS DOUBLE
DIM Int2(TPS&) AS DOUBLE
DIM IntEB(TPS2&) AS DOUBLE

DEF SEG = VARSEG(PicSize(2, 1)): BLOAD "extro2.dat", VARPTR(PicSize(2, 1))
DEF SEG = VARSEG(Int1(0)): BLOAD "extro2_1.pic", VARPTR(Int1(0))
DEF SEG = VARSEG(Int2(0)): BLOAD "extro2_2.pic", VARPTR(Int2(0))
DEF SEG = VARSEG(IntEB(0)): BLOAD "extro2eb.pic", VARPTR(IntEB(0))
DEF SEG

f$ = MKD$(IntEB(0))
EPicSize(3) = CINT(CVI(LEFT$(f$, 2)) \ 8)
EPicSize(4) = CINT(CVI(MID$(f$, 3, 2)))


CLS

NumStars = 100
FOR t = 1 TO NumStars
   Stars(t).X = INT(RND * 320)
   Stars(t).Y = INT(RND * 200)
   Stars(t).p = INT(RND * 16 + 240)
   Stars(t).DX = 0
   Stars(t).DY = 0
NEXT t

ChangePalette 5, 0, 255

x1 = 180
y1 = 190
ln = 0

FOR t = 1 TO 50
 
   OP = PEEK(240): DEF SEG
   
   x1 = x1 - (4 * SIN((t - 15) * 4 * Pi / 180)) * (1 + t / 50)
   y1 = y1 - 2
  
   PUT (0, 0), IntEB(0), PSET
   MoveExpl 1

   PUT (x1 - PicSize(3, t) / 2, y1 - PicSize(4, t) / 2), Int2(PicSize(5, t)), AND
   PUT (x1 - PicSize(3, t) / 2, y1 - PicSize(4, t) / 2), Int1(PicSize(5, t)), XOR

   FOR t2 = 12 TO 30 STEP 6
      IF t >= t2 AND RND > (t - t2) / 40 THEN
         t3 = (t2 / 6 - 1) * 2 - 1
         IF (t - t2) MOD 6 = 1 THEN t3 = t3 + 1
         NewExpl LasData(t3, 3), LasData(t3, 4), 1, 23, 0
      END IF
   NEXT t2

   IF t = 12 OR t = 18 OR t = 24 OR t = 30 OR t = 13 OR t = 19 OR t = 25 OR t = 31 THEN
      ln = ln + 1
      IF t MOD 12 = 0 THEN t3 = 237 ELSE t3 = 238
      LINE (LasData(ln, 1) - 2, LasData(ln, 2))-(LasData(ln, 3), LasData(ln, 4)), 239
      LINE (LasData(ln, 1) + 2, LasData(ln, 2))-(LasData(ln, 3), LasData(ln, 4)), 239
      LINE (LasData(ln, 1) - 1, LasData(ln, 2))-(LasData(ln, 3), LasData(ln, 4)), 238
      LINE (LasData(ln, 1) + 1, LasData(ln, 2))-(LasData(ln, 3), LasData(ln, 4)), 238
      LINE (LasData(ln, 1), LasData(ln, 2))-(LasData(ln, 3), LasData(ln, 4)), t3
   END IF
  

   DEF SEG = 53
   DO
      IF INKEY$ <> "" THEN CLS : Ex1 = 9: EXIT SUB
   LOOP UNTIL PEEK(240) <> OP

NEXT t

CLS

ERASE Int1, IntEB, PicSize
PALETTE 0, 0

END SUB

SUB EndScene3

IntScr = 12

DIM EPicSize(2 TO 5, 1 TO 20) AS INTEGER
DIM PicSize(2 TO 5, 1 TO 30) AS INTEGER

TPS1& = 0: TPS2& = 0

OPEN "extro3e1.pic" FOR INPUT AS #1: TPS2& = TPS2& + LOF(1) \ 8: CLOSE #1
OPEN "extro3e2.pic" FOR INPUT AS #1: TPS2& = TPS2& + LOF(1) \ 8: CLOSE #1
OPEN "extro3.pic" FOR INPUT AS #1: TPS1& = LOF(1) \ 8: CLOSE #1
DIM Int1(TPS1&) AS DOUBLE
DIM IntEn(TPS2&) AS DOUBLE

DEF SEG = VARSEG(PicSize(2, 1)): BLOAD "extro3.dat", VARPTR(PicSize(2, 1))
DEF SEG = VARSEG(Int1(0)): BLOAD "extro3.pic", VARPTR(Int1(0))
DEF SEG = VARSEG(EPicSize(2, 1)): BLOAD "extro3en.dat", VARPTR(EPicSize(2, 1))
DEF SEG = VARSEG(IntEn(EPicSize(5, 1))): BLOAD "extro3e1.pic", VARPTR(IntEn(EPicSize(5, 1)))
DEF SEG = VARSEG(IntEn(EPicSize(5, 11))): BLOAD "extro3e2.pic", VARPTR(IntEn(EPicSize(5, 11)))
DEF SEG

CLS

NumStars = 100
FOR t = 1 TO NumStars
   Stars(t).X = INT(RND * 320)
   Stars(t).Y = INT(RND * 200)
   Stars(t).p = INT(RND * 16 + 240)
   Stars(t).DX = 1
   Stars(t).DY = 0
NEXT t
FOR t = 101 TO 200
   Stars(t).X = (INT(RND * 2) * 2 - 1) * INT(RND * 12 + 1) + E1(1, 1) + 20
   Stars(t).Y = (INT(RND * 2) * 2 - 1) * INT(RND * 12 + 1) + E1(1, 2)
   IF RND > .4 THEN
      Stars(t).p = INT(RND * 12 + 240)
   ELSE
      Stars(t).p = INT(RND * 12 + 176)
   END IF
   t3 = INT(RND * 60 + 70)
   Stars(t).DX = (Stars(t).X - E1(1, 1) - 20) * t3 / 200 + INT(RND * 3 - 1)
   Stars(t).DY = (Stars(t).Y - E1(1, 2)) * t3 / 200 + INT(RND * 3 - 1)
   IF Stars(t).DX = 0 AND Stars(t).DY = 0 THEN Stars(t).DY = -1: Stars(t).DX = -1
NEXT t


ChangePalette 5, 0, 255

x1 = 120
y1 = 100

x2 = 140
y2 = 100

FOR t = 1 TO 1000
   t1 = t \ 2 + 1
   OP = PEEK(240): DEF SEG
   t2 = t + 5

   IF t > 1 AND t <= 21 THEN LINE (x1 - PicSize(3, t2 - 1) / 2, y1 - PicSize(4, t2 - 1) / 2)-(x1 + PicSize(3, t2 - 1) / 2, y1 + PicSize(4, t2 - 1) / 2), 0, BF
   IF t1 > 1 AND t1 <= 21 THEN LINE (x2 - EPicSize(3, t1 - 1) / 2, y2 - EPicSize(4, t1 - 1) / 2)-(x2 + EPicSize(3, t1 - 1) / 2, y2 + EPicSize(4, t1 - 1) / 2), 0, BF
   
   x1 = x1 - 4 - t / 7: y1 = y1 - 1
   x2 = x2 - ((t MOD 2) = 0): y2 = y2
   MoveExpl 0
   IF t <= 20 THEN PUT (x1 - PicSize(3, t2) / 2, y1 - PicSize(4, t2) / 2), Int1(PicSize(5, t2)), PSET
   IF t1 <= 20 THEN PUT (x2 - EPicSize(3, t1) / 2, y2 - EPicSize(4, t1) / 2), IntEn(EPicSize(5, t1)), PSET
     
   MoveStars2

   MoveExpl 1

   IF t1 <= 20 THEN
      FOR t2 = 1 TO 4
         IF (t MOD 20) = 0 THEN E1(t2, 1) = E1(t2, 1) + 1
         IF RND > .5 OR t = 1 THEN NewExpl E1(t2, 1), E1(t2, 2), 0, 25, 1
      NEXT t2
   END IF
   IF RND < t1 / 30 AND t1 < 26 THEN
      IF t1 > 20 THEN t4 = 10 ELSE t4 = 0
      t2 = INT(RND * (21 + t4 * 2) - 10 - t4 + E1(1, 1))
      t3 = INT(RND * (21 + t4 * 2) - 10 - t4 + E1(1, 2))
      FOR t4 = 1 TO INT(RND * 3 + 2)
         NewExpl t2, t3, INT(RND * 2), 27, 1
      NEXT t4
   END IF
   IF t1 = 20 THEN
      MoveExpl 0
      FOR t2 = 1 TO MaxExpl: Expl(t2).p = 0: NEXT t2
      FOR t2 = 1 TO MaxExpl
         NewExpl E1(1, 1), E1(1, 2), t2 MOD 2, 40, 0
      NEXT t2
      NumStars = 200
   END IF
   'IF t1 >= 19 AND t1 <= 30 THEN PALETTE 0, Int3Pal(t - 18)
   IF t >= 38 AND t <= 49 THEN PALETTE 0, Int3Pal(t - 37)
   IF t >= 100 AND t < 200 THEN
      t2 = 300 - t
      PSET (Stars(t2).X, Stars(t2).Y), 0: Stars(t2).p = 0
      NumStars = NumStars - 1
   END IF

   IF t = 74 THEN FontPC(0) = 0
   IF t >= 75 THEN
      RotateFontPal 0
      IF t = 75 THEN Text 0, 97, 80, 0, 0, "CONGRATULATIONS", 5
   END IF
   
   DEF SEG = 53
   DO
      IF INKEY$ <> "" THEN CLS : Ex1 = 9: EXIT SUB
   LOOP UNTIL PEEK(240) <> OP

NEXT t

CLS : Ex1 = 9

ERASE Int1, IntEn, PicSize, EPicSize
PALETTE 0, 0

END SUB

REM $STATIC
SUB GameInfo STATIC

C& = 0: Ex1 = 0
IntScr = 5

'DO
   CLS : ChangePalette 1, 0, 255
   GOSUB DrawPage
   FOR t = 1 TO NumStars
      Stars(t).g = 0
      Stars(t).DY = INT(RND * 5) + 10
      Stars(t).DX = INT(RND * 3) - 1
      Stars(t).p = (Stars(t).p MOD 16) + 112
   NEXT t
 
   DO
      OP = PEEK(284): DEF SEG
      C& = C& + 1
      i$ = INKEY$
      IF i$ <> "" THEN
         IntScr = 0
         FOR t = 1 TO NumStars
            Stars(t).DY = INT(RND * 11 + 2) \ 2
         NEXT t
         CLS
         EXIT SUB
      END IF
      MoveStars2

      RotateFontPal 1
      IF C& MOD 2 THEN RotateFontPal 0
      IF C& MOD 3 = 0 THEN RotateFontPal 2

      DEF SEG = 53
      DO: LOOP UNTIL PEEK(284) <> OP
   LOOP 'UNTIL Ex1
'Ex1 = 0
'LOOP

DrawPage:

Text 1, 105, 10, 0, 0, "ABOUT STARFIRE", 3

Text 2, 30, 38, 0, 0, "Starfire is FREEWARE by David Karlov, 1998", 6
Text 2, 25, 64, 0, 0, "if you have any suggestions, comments, questions, etc", 6
Text 2, 116, 72, 0, 0, "then email me at:", 6
Text 0, 93, 80, 0, 0, "dkarlov@acs.itd.uts.edu.au", 2
Text 2, 8, 112, 0, 0, "Starfire was written and compiled using QuickBASIC 4.5", 6
Text 2, 22, 120, 0, 0, "this game is proof that QuickBASIC is not a " + CHR$(34) + "wimpy" + CHR$(34), 6
Text 2, 30, 128, 0, 0, " language, it can be used to make some cool games", 6
Text 0, 18, 160, 0, 0, "for more information, read the file STARFIRE.TXT", 2

RETURN


END SUB

SUB GetPics STATIC

DIM B AS LONG

' load palette
'ChangePalette 1,0,255

' load images
DEF SEG = VARSEG(FontPics(0)): BLOAD "font.qbs", VARPTR(FontPics(0))
DEF SEG = VARSEG(ShipPics(0)): BLOAD "ship.qbs", VARPTR(ShipPics(0))
DEF SEG = VARSEG(GoodiesPics(0)): BLOAD "goodies.qbs", VARPTR(GoodiesPics(0))
'DEF SEG = VARSEG(LExplodePics(0)): BLOAD "explode.qbs", VARPTR(LExplodePics(0))
'DEF SEG = VARSEG(LExplodeMasks(0)): BLOAD "explode.mas", VARPTR(LExplodeMasks(0))
'DEF SEG = VARSEG(BExplodePics(0)): BLOAD "explode2.qbs", VARPTR(BExplodePics(0))
'DEF SEG = VARSEG(BExplodeMasks(0)): BLOAD "explode2.mas", VARPTR(BExplodeMasks(0))
DEF SEG

FOR t = 1 TO 2
   FOR l = 0 TO 95
      FontPics(t * 3264 + l * 34) = FontPics(l * 34)
      FontPics(t * 3264 + l * 34 + 1) = FontPics(l * 34 + 1)
      FOR B = 2 TO 33
         t2 = FontPics(l * 34 + B)
         b1 = t2 AND 255
         b2 = (t2 - b1) \ 256
         IF b1 >= 1 AND b1 <= 4 THEN t2 = t2 + t * 4
         IF b2 >= 1 AND b2 <= 4 THEN t2 = t2 + t * 1024
         FontPics(t * 3264 + l * 34 + B) = t2
      NEXT B
   NEXT l
NEXT t

FOR t = 2 TO 201
   B = ShipPics(t): IF B < 0 THEN B = B + 65536
   b1 = B AND 255: b2 = (B - b1) \ 256
   IF b1 >= 112 AND b1 <= 127 THEN b1 = b1 + 128
   IF b2 >= 112 AND b2 <= 127 THEN b2 = b2 + 128
   IF b1 >= 176 AND b1 <= 191 THEN b1 = b1 + 48
   IF b2 >= 176 AND b2 <= 191 THEN b2 = b2 + 48
   B = b2 * 256& + b1: IF B > 32767 THEN B = B - 65536
   ShipPics(t) = B
NEXT t

RESTORE InstrData
FOR t = 1 TO 13
   READ Instruct(t), S$
   Instruct(t) = Instruct(t) + S$
NEXT t


END SUB

SUB HiScore (Score AS LONG)

IntScr = 0

DIM HiNames(1 TO 10) AS STRING * 16
DIM HiScores(1 TO 10) AS STRING * 8

CLS
NumStars = 100
InitStars
   OPEN "hiscore.dat" FOR INPUT AS #1
   t2 = 0
   FOR t = 1 TO 10
      INPUT #1, HiNames(t), HiScores(t)
      IF t2 = 0 AND Score > VAL(HiScores(t)) THEN t2 = t
   NEXT t
   CLOSE #1
   IF t2 THEN
      FOR t = 9 TO t2 STEP -1
         HiScores(t + 1) = HiScores(t)
         HiNames(t + 1) = HiNames(t)
      NEXT t
      hs$ = ""
      Text 0, 120, 30, 0, 0, "HIGH SCORE!!!", 3
      Text 1, 240, 80, 0, 0, STR$(Score), 6

      DO
         OP = PEEK(284): DEF SEG
   
         i$ = INKEY$
         SELECT CASE i$
            CASE " " TO CHR$(126)
               IF LEN(hs$) < 16 THEN hs$ = hs$ + i$
            CASE CHR$(8)
               IF LEN(hs$) > 0 THEN hs$ = LEFT$(hs$, LEN(hs$) - 1)
            CASE CHR$(13)
               Ex1 = 1
         END SELECT
         Text 2, 80, 80, 0, 0, hs$ + "_ ", 2
        
         MoveStars 0, 0
         RotateFontPal 1: RotateFontPal 2: RotateFontPal 0

         DEF SEG = 53
         DO: LOOP UNTIL PEEK(284) <> OP
        
      LOOP UNTIL Ex1 = 1

      HiScores(t2) = RIGHT$("00000000" + RTRIM$(LTRIM$(STR$(Score))), 8)
      HiNames(t2) = LEFT$(hs$ + SPACE$(16), 16)

      OPEN "hiscore.dat" FOR OUTPUT AS #1
      FOR t = 1 TO 10
         PRINT #1, HiNames(t)
         PRINT #1, HiScores(t)
      NEXT t
      CLOSE #1
   END IF
 
   CLS : DispHiScores

END SUB

SUB Init

RANDOMIZE TIMER
SCREEN 13, 0, 0, 0: CLS

SetLocks 1

'GetPics

FontPC(0) = 1: FontPC(1) = 1: FontPC(2) = 1

OPEN "starfire.dat" FOR INPUT AS #1
FOR t = 0 TO 95: INPUT #1, FontWidth(t): NEXT t
FOR t = 1 TO 6: FOR t2 = 1 TO 4
   INPUT #1, FontPal(t, t2)
NEXT t2, t
CLOSE #1
FOR t = 7 TO 11: FOR t2 = 1 TO 4
   FontPal(t, t2) = FontPal(12 - t, 5 - t2)
NEXT t2, t
FOR t = 12 TO 20: FOR t2 = 1 TO 4
   FontPal(t, t2) = FontPal(22 - t, t2)
NEXT t2, t

FOR t = 1 TO 25: READ FadeDat(t): NEXT t


END SUB

SUB InitStars STATIC

FOR t = 1 TO NumStars
   NewStar t
   Stars(t).g = 0
   Stars(t).Y = INT(RND * 200)
NEXT t

END SUB

SUB Instructions

CLS

DIM PicSize(2 TO 5, 1 TO 40) AS INTEGER

OPEN "Instru_1.pic" FOR INPUT AS #1: TPS& = LOF(1) - 7: CLOSE #1
OPEN "Instru_2.pic" FOR INPUT AS #1: TPS& = TPS& + LOF(1) - 7: CLOSE #1
DIM Int1((TPS& + 7) \ 8) AS DOUBLE

DEF SEG = VARSEG(PicSize(2, 1)): BLOAD "InstruPS.dat", VARPTR(PicSize(2, 1))
DEF SEG = VARSEG(Int1(0)): BLOAD "instru_1.pic", VARPTR(Int1(0))
DEF SEG = VARSEG(Int1(PicSize(5, 21))): BLOAD "instru_2.pic", VARPTR(Int1(PicSize(5, 21)))
DEF SEG

NumPages = 5
Page = 1: C& = 0: Ex1 = 0

DO

   CLS
   IF Page = 2 THEN
      IntScr = 4
      ChangePalette 4, 0, 255
      FOR t = 1 TO NumStars
         Stars(t).p = Stars(t).p MOD 16 + 240
         Stars(t).g = 0
      NEXT t
   ELSE
      IntScr = 20
      ChangePalette 1, 0, 255
      FOR t = 1 TO NumStars
         Stars(t).p = Stars(t).p MOD 16 + 112
         Stars(t).g = 0
      NEXT t
   END IF

   RotateFontPal 0: RotateFontPal 1: RotateFontPal 2
  
   ON Page GOSUB Page1, Page2, Page3, Page4, Page5
   FOR t = 1 TO NumStars: Stars(t).g = 0: NEXT t
'   WHILE INKEY$ <> "": WEND

   DO
      OP = PEEK(284): DEF SEG
      C& = C& + 1
      i$ = INKEY$
      SELECT CASE UCASE$(i$)
         CASE ""
         CASE CHR$(0) + "K", CHR$(0) + "H", CHR$(0) + "I", "-"
            IF Page > 1 THEN Page = Page - 1: Ex1 = 1
         CASE CHR$(0) + "M", CHR$(0) + "P", CHR$(0) + "Q", "+"
            IF Page < NumPages THEN Page = Page + 1: Ex1 = 1
         CASE " ", CHR$(13)
            IF Page < NumPages THEN
               Page = Page + 1: Ex1 = 1
            ELSE
               CLS
               ChangePalette 1, 0, 255
               IntScr = 0
               EXIT SUB
            END IF
         CASE CHR$(0) + "G"
            IF Page > 1 THEN Page = 1: Ex1 = 1
         CASE CHR$(0) + "O"
            IF Page < NumPages THEN Page = NumPages: Ex1 = 1
         CASE CHR$(27)
            CLS
            IntScr = 0
            ChangePalette 1, 0, 255
            EXIT SUB
         CASE "1" TO "9"
            IF VAL(i$) <= NumPages AND Page <> VAL(i$) THEN Page = VAL(i$): Ex1 = 1
      END SELECT
  
      IF Page = 2 AND Ex1 = 0 THEN PUT (120, 148), Int1(PicSize(5, (C& MOD 40) + 1)), PSET
      MoveStars 0, 1

      RotateFontPal 1
      IF C& MOD 2 THEN RotateFontPal 0
      IF C& MOD 3 = 0 THEN RotateFontPal 2

      DEF SEG = 53
      DO: LOOP UNTIL PEEK(284) <> OP
   LOOP UNTIL Ex1
Ex1 = 0

LOOP



Page1:

   Text 2, 118, 1, 0, 0, "GAME MODES", 2
  
   Text 1, 15, 17, 0, 0, "MISSION MODE", 3
   Text 0, 30, 25, 319, 0, Instruct(1), 6

   Text 1, 15, 107, 0, 0, "PRACTICE MODE", 3
   Text 0, 30, 115, 319, 0, Instruct(2), 6
  
   Text 1, 5, 190, 0, 0, "instructions", 3
   Text 1, 250, 190, 0, 0, "page 1 of 5", 3
RETURN

Page2:
  
   Text 2, 122, 1, 0, 0, "YOUR SHIP", 2
   PUT (20, 20), ShipPics(0), PSET
   Text 0, 50, 20, 319, 0, Instruct(3), 6
   Text 0, 20, 61, 319, 0, Instruct(4), 6
   Text 0, 20, 110, 319, 0, Instruct(5), 6

   Text 1, 5, 190, 0, 0, "instructions", 3
   Text 1, 250, 190, 0, 0, "page 2 of 5", 3
RETURN

Page3:

   Text 2, 122, 1, 0, 0, "POWER-UPS", 1

   PUT (12, 27), GoodiesPics(52 * 5), PSET
   Text 1, 30, 29, 0, 0, "EXTRA SHIP", 3
   Text 0, 45, 37, 319, 0, Instruct(6), 2

   PUT (12, 70), GoodiesPics(52 * 4), PSET
   Text 1, 30, 72, 0, 0, "SPEED BOOSTER", 3
   Text 0, 45, 80, 0, 0, Instruct(7), 2

   PUT (12, 120), GoodiesPics(52 * 6), PSET
   Text 1, 30, 122, 0, 0, "SHIELD BOOSTER", 3
   Text 0, 45, 130, 0, 0, Instruct(8), 2

   Text 1, 5, 190, 0, 0, "instructions", 3
   Text 1, 250, 190, 0, 0, "page 3 of 5", 3
RETURN

Page4:
   Text 2, 128, 1, 0, 0, "WEAPONS", 1

   PUT (12, 12), GoodiesPics(0), PSET
   Text 1, 30, 14, 0, 0, "PULSE CANNON", 3
   Text 0, 45, 22, 319, 0, Instruct(9), 2

   PUT (12, 57), GoodiesPics(52), PSET
   Text 1, 30, 59, 0, 0, "SCATTERGUN", 3
   Text 0, 45, 67, 319, 0, Instruct(10), 2

   PUT (12, 102), GoodiesPics(52 * 2), PSET
   Text 1, 30, 104, 0, 0, "LASER", 3
   Text 0, 45, 112, 319, 0, Instruct(11), 2

   PUT (12, 147), GoodiesPics(52 * 3), PSET
   Text 1, 30, 149, 0, 0, "DEVASTATION BOMB", 3
   Text 0, 45, 157, 319, 0, Instruct(12), 2

   Text 1, 5, 190, 0, 0, "instructions", 3
   Text 1, 250, 190, 0, 0, "page 4 of 5", 3
RETURN

Page5:
   Text 1, 122, 10, 0, 0, "GAME KEYS", 2
   Text 0, 30, 25, 0, 0, "MOVEMENT:", 3
   Text 1, 50, 40, 0, 0, "ALT", 2
   Text 1, 50, 50, 0, 0, "CTRL", 2
   Text 2, 160, 40, 0, 0, "move ship left", 6
   Text 2, 160, 50, 0, 0, "move ship right", 6
   Text 0, 30, 70, 0, 0, "WEAONS:", 3
   Text 1, 50, 85, 0, 0, "SHIFT", 2
   Text 1, 50, 95, 0, 0, "TAB, Z", 2
   Text 1, 50, 105, 0, 0, "SPACE BAR, B", 2
   Text 2, 160, 85, 0, 0, "fire current weapon", 6
   Text 2, 160, 95, 0, 0, "switch weapons", 6
   Text 2, 160, 105, 0, 0, "fire devastation bomb", 6
   Text 0, 30, 125, 0, 0, "GENERAL:", 3
   Text 1, 50, 140, 0, 0, "F1, H, ?", 2
   Text 1, 50, 150, 0, 0, "F2, S", 2
   Text 1, 50, 160, 0, 0, "F4, P, ENTER", 2
   Text 1, 50, 170, 0, 0, "F10, Q, ESC", 2
   Text 2, 160, 140, 0, 0, "bring up help screen in play", 6
   Text 2, 160, 150, 0, 0, "toggle sound on/off", 6
   Text 2, 160, 160, 0, 0, "pause and display game info", 6
   Text 2, 160, 170, 0, 0, "quit game", 6
   Text 0, 5, 190, 0, 0, "instructions", 3
   Text 0, 250, 190, 0, 0, "page 5 of 5", 3
RETURN

END SUB

REM $DYNAMIC
SUB Intro1

IntScr = 1

DIM PicSize(2 TO 5, 1 TO 30) AS INTEGER' size of each image in bytes
                                       ' and elements in a DOUBLE array
                                       ' then x width and y width
                                       ' then where the pic starts in the array

OPEN "Intro1_1.pic" FOR INPUT AS #1: TPS& = LOF(1) - 7: CLOSE #1
OPEN "Intro1_2.pic" FOR INPUT AS #1: TPS& = TPS& + LOF(1) - 7: CLOSE #1
OPEN "Intro1_3.pic" FOR INPUT AS #1: TPS& = TPS& + LOF(1) - 7: CLOSE #1

DIM Int1((TPS& + 7) \ 8) AS DOUBLE

DEF SEG = VARSEG(PicSize(2, 1)): BLOAD "Intro1PS.dat", VARPTR(PicSize(2, 1))
DEF SEG = VARSEG(Int1(0)): BLOAD "intro1_1.pic", VARPTR(Int1(0))
DEF SEG = VARSEG(Int1(PicSize(5, 13))): BLOAD "intro1_2.pic", VARPTR(Int1(PicSize(5, 13)))
DEF SEG = VARSEG(Int1(PicSize(5, 23))): BLOAD "intro1_3.pic", VARPTR(Int1(PicSize(5, 23)))
DEF SEG

CLS

NumStars = 60
FOR t = 1 TO NumStars
   Stars(t).X = INT(RND * 320)
   Stars(t).Y = INT(RND * 200)
   Stars(t).p = INT(RND * 16 + 240)
   t2 = INT(RND * 4 + 1)
   t2 = 4
   Stars(t).DX = 2 * t2
   Stars(t).DY = t2
NEXT t

ChangePalette 2, 0, 255

x1 = 260
y1 = 145

FOR t = 1 TO 30
   
   OP = PEEK(284): DEF SEG
   IF t > 1 THEN LINE (x1 - PicSize(3, t - 1) / 2, y1 - PicSize(4, t - 1) / 2)-(x1 + PicSize(3, t - 1) / 2, y1 + PicSize(4, t - 1) / 2), 0, BF
   x1 = x1 - 7: y1 = y1 - 3
   PUT (x1 - PicSize(3, t) / 2, y1 - PicSize(4, t) / 2), Int1(PicSize(5, t)), PSET
   
   MoveStars2

   DEF SEG = 53
   DO
      IF INKEY$ <> "" THEN CLS : Ex1 = 9: EXIT SUB
   LOOP UNTIL PEEK(284) <> OP

NEXT t

CLS
ERASE Int1, PicSize

DIM FontPics(34 * 96 * 3) AS INTEGER' 8 x 8 = 68 bytes
DEF SEG = VARSEG(FontPics(0)): BLOAD "font.qbs", VARPTR(FontPics(0))

FontPC(0) = 1
Text 0, 112, 96, 0, 0, "DAVID KARLOV", 0
FontCol(0).Red = 1
FontCol(0).Green = 0
FontCol(0).Blue = 0
t2 = 0
DO
   OP = PEEK(284): DEF SEG
   t2 = t2 + 1
   IF INKEY$ <> "" THEN CLS : Ex1 = 9: EXIT SUB
   
      IF t2 MOD 2 THEN FontPC(0) = FontPC(0) MOD 20 + 1
      REDIM Temp(1 TO 4) AS Colour
      FOR t = 1 TO 4
         Temp(t).Red = ((FontCol(0).Red * FontPal(FontPC(0), t - 0 * 4)) * FadeDat(t2) / 100)
         Temp(t).Green = ((FontCol(0).Green * FontPal(FontPC(0), t - 0 * 4)) * FadeDat(t2) / 100)
         Temp(t).Blue = ((FontCol(0).Blue * FontPal(FontPC(0), t - 0 * 4)) * FadeDat(t2) / 100)
      NEXT t
      SetPalette Temp(), 1, 4
  
   DEF SEG = 53
   DO: LOOP UNTIL PEEK(284) <> OP
LOOP UNTIL t2 >= 25

ERASE FontPics
CLS

END SUB

SUB Intro2

P2Start = 1 ''''''''

IntScr = 2

DIM PicSize(2 TO 5, 1 TO 40) AS INTEGER
DIM EnPicSize(2 TO 5, 1 TO 20) AS INTEGER
DIM ShellSize(2 TO 5, 1 TO 10) AS INTEGER

   OPEN "intro2en.pic" FOR INPUT AS #1
   TPS3& = LOF(1) \ 8
   CLOSE #1
   DIM IntEn(TPS3&) AS DOUBLE

   DEF SEG = VARSEG(EnPicSize(2, 1))
   BLOAD "Intro2En.dat", VARPTR(EnPicSize(2, 1))
   DEF SEG = VARSEG(IntEn(0))
   BLOAD "Intro2En.pic", VARPTR(IntEn(0))
   DEF SEG

   OPEN "intro2sh.pic" FOR INPUT AS #1
   TPS4& = LOF(1) \ 8
   CLOSE #1

   DIM IntSh(TPS4&) AS DOUBLE

   DEF SEG = VARSEG(ShellSize(2, 1))
   BLOAD "Intro2Sh.dat", VARPTR(ShellSize(2, 1))
   DEF SEG = VARSEG(IntSh(0))
   BLOAD "Intro2Sh.pic", VARPTR(IntSh(0))
   DEF SEG



TPS1& = 0: TPS2& = 0
OPEN "intro2_1.pic" FOR INPUT AS #1: TPS1& = LOF(1): W& = LOF(1): CLOSE #1
OPEN "intro2_2.pic" FOR INPUT AS #1: TPS1& = TPS1& + LOF(1): CLOSE #1
OPEN "intro2_3.pic" FOR INPUT AS #1: TPS1& = TPS1& + LOF(1): CLOSE #1
OPEN "intro2_4.pic" FOR INPUT AS #1: TPS1& = TPS1& + LOF(1): CLOSE #1
OPEN "intro2_5.pic" FOR INPUT AS #1: TPS2& = LOF(1): CLOSE #1
W& = 1''''
DIM Int1((W& + 7) \ 8 - 1 TO (TPS1& + 7) / 8) AS DOUBLE '''''''
DIM Int2((TPS2& + 7) / 8) AS DOUBLE

DEF SEG = VARSEG(PicSize(2, 1)): BLOAD "Intro2PS.dat", VARPTR(PicSize(2, 1))
DEF SEG = VARSEG(Int1(0)): BLOAD "intro2_1.pic", VARPTR(Int1(0)) ''''''
DEF SEG = VARSEG(Int1(PicSize(5, 4))): BLOAD "intro2_2.pic", VARPTR(Int1(PicSize(5, 4)))
DEF SEG = VARSEG(Int1(PicSize(5, 8))): BLOAD "intro2_3.pic", VARPTR(Int1(PicSize(5, 8)))
DEF SEG = VARSEG(Int1(PicSize(5, 13))): BLOAD "intro2_4.pic", VARPTR(Int1(PicSize(5, 13)))
DEF SEG = VARSEG(Int2(0)): BLOAD "intro2_5.pic", VARPTR(Int2(0))
DEF SEG

IntScr = 2
CLS

NumStars = 60
FOR t = 1 TO NumStars
   Stars(t).X = INT(RND * 320)
   Stars(t).Y = INT(RND * 200)
   Stars(t).p = INT(RND * 16 + 240)
   t2 = INT(RND * 3 + 1)
   Stars(t).DX = 0
   Stars(t).DY = t2 * 6 * 0 + 12
NEXT t

ChangePalette 2, 0, 255

x1 = 160
y1 = 130

x2 = 198 + 30: y2 = -20

FOR t = P2Start TO 40
   t2 = t - 20: t3 = t - 30

   OP = PEEK(284): DEF SEG
   IF t > P2Start THEN LINE (x1 - PicSize(3, t - 1) / 2, y1 - PicSize(4, t - 1) / 2)-(x1 + PicSize(3, t - 1) / 2, y1 + PicSize(4, t - 1) / 2), 0, BF
   IF t2 > 1 THEN LINE (x2 - EnPicSize(3, t2 - 1) / 2, y2 - EnPicSize(4, t2 - 1) / 2)-(x2 + EnPicSize(3, t2 - 1) / 2, y2 + EnPicSize(4, t2 - 1) / 2), 0, BF
   IF t3 > 1 THEN LINE (x3 - ShellSize(3, t3 - 1) / 2, y3 - ShellSize(4, t3 - 1) / 2)-(x3 + ShellSize(3, t3 - 1) / 2, y3 + ShellSize(4, t3 - 1) / 2), 0, BF
   x1 = x1: y1 = y1 + 1
   IF t > 20 THEN y1 = y1 - 1
   IF t > 24 THEN y1 = y1 - 1
   IF t > 28 THEN y1 = y1 - 1
   IF t > 32 THEN y1 = y1 - 1
   IF t > 26 AND t < 35 THEN x1 = x1 - 1

   IF t2 > 0 THEN y2 = y2 + 4: x2 = x2 - 2
   IF t2 > 2 THEN y2 = y2 - 1
   IF t2 > 8 THEN y2 = y2 - 1
   IF t2 > 9 AND t2 < 12 THEN y2 = y2 - 1

   IF t3 = 0 THEN y3 = y2 + 3: x3 = x2 + 2
   IF t3 > 0 THEN y3 = y3 + 16: x3 = x3 - 4
  
   IF t2 > 0 THEN
'      PUT (x2 - EnPicSize(3, t2) / 2, y2 - EnPicSize(4, t2) / 2), IntEn(EnPicSize(5, t2)), PSET
      VPutDBL x2 - EnPicSize(3, t2) / 2, y2 - EnPicSize(4, t2) / 2, IntEn(), CLNG(EnPicSize(5, t2)), 1, 0, 199
   END IF

   IF t3 > 0 THEN
      PUT (x3 - ShellSize(3, t3) / 2, y3 - ShellSize(4, t3) / 2), IntSh(ShellSize(5, t3)), PSET
'      VPutDBL x2 - EnPicSize(3, t2) / 2, y2 - EnPicSize(4, t2) / 2, IntEn(), CLNG(EnPicSize(5, t2)), 1, 0, 199
   END IF
  
   IF t < 21 THEN
      PUT (x1 - PicSize(3, t) / 2, y1 - PicSize(4, t) / 2), Int1(PicSize(5, t)), PSET
   ELSE
      PUT (x1 - PicSize(3, t) / 2, y1 - PicSize(4, t) / 2), Int2(PicSize(5, t)), PSET
   END IF


   MoveStars2
   IF t = 10 THEN
      IntScr = -5
      FOR t2 = 1 TO NumStars
         Stars(t2).DY = 9 'Stars(t2).DY / 6 * 5
      NEXT t2
   ELSEIF t = 13 THEN
      IntScr = -4
      FOR t2 = 1 TO NumStars
         Stars(t2).DY = 6 'Stars(t2).DY / 5 * 4
      NEXT t2
   ELSEIF t = 17 THEN
      IntScr = -3
      FOR t2 = 1 TO NumStars
         Stars(t2).DY = 4 'Stars(t2).DY / 4 * 3
      NEXT t2
   ELSEIF t = 22 THEN
      IntScr = -2
      FOR t2 = 1 TO NumStars
         Stars(t2).DY = 2 'Stars(t2).DY / 3 * 2
      NEXT t2
   ELSEIF t = 28 THEN
      IntScr = -1
      FOR t2 = 1 TO NumStars
         Stars(t2).DY = 1 'Stars(t2).DY / 2
      NEXT t2
   END IF
   DEF SEG = 53
   DO
      IF INKEY$ <> "" THEN CLS : Ex1 = 9: EXIT SUB
   LOOP UNTIL PEEK(284) <> OP

NEXT t

CLS
ERASE Int1, PicSize

DIM FontPics(34 * 96 * 3) AS INTEGER' 8 x 8 = 68 bytes
DEF SEG = VARSEG(FontPics(0)): BLOAD "font.qbs", VARPTR(FontPics(0))

FontPC(0) = 1
Text 0, 140, 96, 0, 0, "presents", 0
FontCol(0).Red = 1
FontCol(0).Green = 0
FontCol(0).Blue = 1
t2 = 0
DO
   OP = PEEK(284): DEF SEG
   t2 = t2 + 1
   IF INKEY$ <> "" THEN CLS : Ex1 = 9: EXIT SUB
     
      IF t2 MOD 2 THEN FontPC(0) = FontPC(0) MOD 20 + 1
      REDIM Temp(1 TO 4) AS Colour
      FOR t = 1 TO 4
         Temp(t).Red = ((FontCol(0).Red * FontPal(FontPC(0), t - 0 * 4)) * FadeDat(t2) / 100)
         Temp(t).Green = ((FontCol(0).Green * FontPal(FontPC(0), t - 0 * 4)) * FadeDat(t2) / 100)
         Temp(t).Blue = ((FontCol(0).Blue * FontPal(FontPC(0), t - 0 * 4)) * FadeDat(t2) / 100)
      NEXT t
      SetPalette Temp(), 1, 4
 
   DEF SEG = 53
   DO: LOOP UNTIL PEEK(284) <> OP
LOOP UNTIL t2 >= 25

CLS
ERASE FontPics

END SUB

SUB Intro3

IntScr = 3

DIM TitPos(1 TO 5) AS INTEGER
TitPos(1) = 0: TitPos(2) = 17: TitPos(3) = 82
TitPos(4) = 339: TitPos(5) = 1364
DIM Title(5461) AS DOUBLE
DEF SEG = VARSEG(Title(0)): BLOAD "title_0.pic", VARPTR(Title(0)): DEF SEG

DIM PicSize(2 TO 5, 1 TO 36) AS INTEGER
DIM EnPicSize(2 TO 5, 1 TO 40) AS INTEGER

OPEN "intro3en.pic" FOR INPUT AS #1: TPSE& = LOF(1) / 8: CLOSE #1
DIM IntEn(TPSE&) AS DOUBLE
DEF SEG = VARSEG(EnPicSize(2, 1)): BLOAD "intro3EN.dat", VARPTR(EnPicSize(2, 1))
DEF SEG = VARSEG(IntEn(0)): BLOAD "intro3EN.pic", VARPTR(IntEn(0))
DEF SEG

OPEN "intro3_1.pic" FOR INPUT AS #1: TPS& = LOF(1) / 8: CLOSE #1
DIM Int1(TPS&) AS DOUBLE
DEF SEG = VARSEG(PicSize(2, 1)): BLOAD "Intro3ps.dat", VARPTR(PicSize(2, 1))
DEF SEG = VARSEG(Int1(0)): BLOAD "intro3_1.pic", VARPTR(Int1(0))
DEF SEG


IntScr = 3
CLS

NumStars = 60
FOR t = 1 TO NumStars
   Stars(t).X = INT(RND * 320)
   Stars(t).Y = INT(RND * 200)
   Stars(t).p = INT(RND * 16 + 240)
   t2 = INT(RND * 2)
   Stars(t).DX = 9 + t2
   Stars(t).DY = 0
NEXT t

FOR t = 1 TO MaxExpl
   Expl(t).p = 0
NEXT t


ChangePalette 3, 0, 255

x1 = 266
y1 = 150

x2 = 40: y2 = 20

FOR t = 1 TO 45
  
   OP = PEEK(284): DEF SEG
  
   IF t >= 31 THEN
      IntScr = 4
      FOR t2 = 1 TO NumStars
         Stars(t2).DX = 9 + (Stars(t2).X - 160) \ 5
         Stars(t2).DY = (Stars(t2).Y - 100) \ 5
      NEXT t2
   END IF

   IF t > 1 THEN
      IF t <= 37 THEN LINE (x1 - PicSize(3, t - 1) / 2, y1 - PicSize(4, t - 1) / 2)-(x1 + PicSize(3, t - 1) / 2, y1 + PicSize(4, t - 1) / 2), 0, BF
      IF t <= 31 THEN LINE (x2 - EnPicSize(3, t - 1) / 2, y2 - EnPicSize(4, t - 1) / 2)-(x2 + EnPicSize(3, t - 1) / 2, y2 + EnPicSize(4, t - 1) / 2), 0, BF
   END IF
   x1 = x1 - 3: y1 = y1 - 1
   IF t > 20 THEN x1 = x1 + 1
   IF t > 30 THEN y1 = y1 + t - 15: x1 = x1 - (t - 30)

   x2 = x2 + 4: y2 = y2 + 2
   IF t > 30 THEN x2 = x2 - 2

   IF t = 22 THEN
      LINE (180, 118)-(-20, -4), 0
      LINE (179, 118)-(-20, -4), 0
      LINE (181, 118)-(-20, -4), 0
      LINE (179, 119)-(-20, -4), 0
      LINE (181, 117)-(-20, -4), 0
   ELSEIF t = 23 THEN
      LINE (179, 117)-(-15, -4), 0
      LINE (178, 117)-(-15, -4), 0
      LINE (180, 117)-(-15, -4), 0
      LINE (178, 118)-(-15, -4), 0
      LINE (180, 116)-(-15, -4), 0
   ELSEIF t = 29 THEN
      LINE (175, 111)-(100, 23), 0
      LINE (174, 111)-(100, 23), 0
      LINE (176, 111)-(100, 23), 0
      LINE (173, 111)-(100, 23), 0
      LINE (177, 111)-(100, 23), 0
   ELSEIF t = 30 THEN
      LINE (175, 111)-(106, 23), 0
      LINE (174, 111)-(106, 23), 0
      LINE (176, 111)-(106, 23), 0
      LINE (173, 111)-(106, 23), 0
      LINE (177, 111)-(106, 23), 0
   END IF

   IF t > 30 THEN MoveExpl 0

'   PUT (x1 - PicSize(3, t) / 2, y1 - PicSize(4, t) / 2), Int1(PicSize(5, t)), PSET
   IF t <= 36 THEN VPutDBL x1 - PicSize(3, t) / 2, y1 - PicSize(4, t) / 2, Int1(), CDBL(PicSize(5, t)), 1, 0, 199
   IF t <= 30 THEN PUT (x2 - EnPicSize(3, t) / 2, y2 - EnPicSize(4, t) / 2), IntEn(EnPicSize(5, t)), PSET
  
   IF t = 21 THEN
      LINE (180, 118)-(-20, -4), 237
      LINE (179, 118)-(-20, -4), 238
      LINE (181, 118)-(-20, -4), 238
      LINE (179, 119)-(-20, -4), 239
      LINE (181, 117)-(-20, -4), 239
   ELSEIF t = 22 THEN
      LINE (179, 117)-(-15, -4), 238
      LINE (178, 117)-(-15, -4), 238
      LINE (180, 117)-(-15, -4), 238
      LINE (178, 118)-(-15, -4), 239
      LINE (180, 116)-(-15, -4), 239
   ELSEIF t = 28 THEN
      LINE (175, 111)-(100, 23), 237
      LINE (174, 111)-(100, 23), 238
      LINE (176, 111)-(100, 23), 238
      LINE (173, 111)-(100, 23), 239
      LINE (177, 111)-(100, 23), 239
   ELSEIF t = 29 THEN
      LINE (175, 111)-(106, 23), 238
      LINE (174, 111)-(106, 23), 238
      LINE (176, 111)-(106, 23), 238
      LINE (173, 111)-(106, 23), 239
      LINE (177, 111)-(106, 23), 239
   ELSEIF t = 37 THEN
      PALETTE 31, 0
      OUT &H3C8, 64
      FOR t2 = 64 TO 127
         OUT &H3C9, 63
         OUT &H3C9, t2 - 64
         OUT &H3C9, 0
      NEXT t2
   END IF

   IF t = 30 THEN
      SetPalette RedCol(), 160, 175
   END IF

   IF t >= 30 AND t <= 38 THEN
      NewExpl x2, y2, 0, t, 0
      NewExpl x2, y2, 1, t, 0
      FOR t2 = 1 TO (t - 30) \ 2
         NewExpl x2, y2, INT(RND * 2), t, 0
      NEXT t2
   END IF
   IF t >= 41 THEN
      t2 = 2 ^ (t - 37)
      VPutDBL 160 - t2 \ 2, 89 - 3 * t2 \ 8, Title(), CLNG(TitPos(t - 40)), 1, 0, 199
   END IF
   IF t >= 30 THEN MoveExpl 1
   IF t >= 43 AND t <= 45 THEN
      PALETTE 0, Int3Pal(t - 42)'''''''
      PALETTE 31, Int3Pal(t - 42)'''''''
   END IF
  
   MoveStars2
   DEF SEG = 53
   DO
      IF INKEY$ <> "" THEN CLS : Ex1 = 9: EXIT SUB
   LOOP UNTIL PEEK(284) <> OP

NEXT t

ERASE Int1, PicSize, IntEn, EnPicSize




END SUB

REM $STATIC
SUB Introdat

'TPSE& = 0
'FOR t = 1 TO 30
'   f$ = "intro6"
'   IF t < 10 THEN f$ = f$ + "0"
'   f$ = f$ + LTRIM$(RTRIM$(STR$(t))) + ".qbi"
'   OPEN f$ FOR INPUT AS #1
'      EnPicSize(2, t) = LOF(1) \ 8
'   CLOSE #1
'   TPSE& = TPSE& + EnPicSize(2, t)
'NEXT t
'FOR t = 1 TO 30
'   FOR t2 = 1 TO t - 1
'      EnPicSize(5, t) = EnPicSize(5, t) + EnPicSize(2, t2)
'   NEXT t2
'NEXT t

'DIM IntEn(TPSE&) AS DOUBLE
'FOR t = 1 TO 30
'   f$ = "intro6"
'   IF t < 10 THEN f$ = f$ + "0"
'   f$ = f$ + LTRIM$(RTRIM$(STR$(t))) + ".qbi"
'   DEF SEG = VARSEG(IntEn(EnPicSize(5, t)))
'   BLOAD f$, VARPTR(IntEn(EnPicSize(5, t)))
'NEXT t

'FOR t = 1 TO 30
'   f$ = MKD$(IntEn(EnPicSize(5, t)))
'   EnPicSize(3, t) = CINT(CVI(LEFT$(f$, 2)) \ 8)
'   EnPicSize(4, t) = CINT(CVI(MID$(f$, 3, 2)))
'NEXT t

'DEF SEG = VARSEG(EnPicSize(2, 1))
'BSAVE "intro3EN.dat", VARPTR(EnPicSize(2, 1)), 320
'DEF SEG = VARSEG(IntEn(0))
'BSAVE "intro3EN.pic", VARPTR(IntEn(0)), TPSE& * 8
'DEF SEG



'TPS& = 0
'FOR t = 1 TO 36
'   f$ = "intro5"
'   IF t < 10 THEN f$ = f$ + "0"
'   f$ = f$ + LTRIM$(RTRIM$(STR$(t))) + ".qbi"
'   OPEN f$ FOR INPUT AS #1
'      PicSize(2, t) = LOF(1) \ 8
'   CLOSE #1
'   TPS& = TPS& + PicSize(2, t)
'NEXT t
'FOR t = 1 TO 36
'   FOR t2 = 1 TO t - 1
'      PicSize(5, t) = PicSize(5, t) + PicSize(2, t2)
'   NEXT t2
'NEXT t
'
'DIM Int1(TPS&) AS DOUBLE
'FOR t = 1 TO 36
'   f$ = "intro5"
'   IF t < 10 THEN f$ = f$ + "0"
'   f$ = f$ + LTRIM$(RTRIM$(STR$(t))) + ".qbi"
'   DEF SEG = VARSEG(Int1(PicSize(5, t)))
'   BLOAD f$, VARPTR(Int1(PicSize(5, t)))
'NEXT t
'
'FOR t = 1 TO 36
'   f$ = MKD$(Int1(PicSize(5, t)))
'   PicSize(3, t) = CINT(CVI(LEFT$(f$, 2)) \ 8)
'   PicSize(4, t) = CINT(CVI(MID$(f$, 3, 2)))
'NEXT t
'DEF SEG = VARSEG(PicSize(2, 1))
'BSAVE "Intro3ps.dat", VARPTR(PicSize(2, 1)), 288
'DEF SEG = VARSEG(Int1(0))
'BSAVE "intro3_1.pic", VARPTR(Int1(0)), TPS& * 8
'DEF SEG

END SUB

SUB MoveExpl (n AS INTEGER) STATIC
  
IF n = 0 THEN  ' erase
  
   FOR t = 1 TO MaxExpl
      SELECT CASE Expl(t).p
         CASE 0
         CASE -5, -18
            IF Expl(t).p = -5 THEN t2 = 7 ELSE t2 = 14
            LINE (Expl(t).X - t2, Expl(t).Y - t2)-(Expl(t).X + t2, Expl(t).Y + t2), 0, BF
            Expl(t).p = 0
            IF Expl(t).p = -5 THEN t2 = 7 ELSE t2 = 14
            LINE (Expl(t).X - t2, Expl(t).Y - t2)-(Expl(t).X + t2, Expl(t).Y + t2), 0, BF
         CASE -4 TO -1, -17 TO -11   ' exploding small or big
            IF Expl(t).p > -5 THEN t2 = 7 ELSE t2 = 14
            LINE (Expl(t).X - t2, Expl(t).Y - t2)-(Expl(t).X + t2, Expl(t).Y + t2), 0, BF
      END SELECT
   NEXT t

ELSE   ' draw
 
   FOR t = 1 TO MaxExpl
      SELECT CASE Expl(t).p
         CASE -4 TO -1, -17 TO -11   ' exploding small or big
            Expl(t).X = Expl(t).X + Expl(t).DX
            Expl(t).Y = Expl(t).Y + Expl(t).DY
            IF Expl(t).p > -5 THEN
               'CheckPos t, 7
               PUT (Expl(t).X - 7, Expl(t).Y - 7), LExplodeMasks(100 * (-1 - Expl(t).p)), AND
               PUT (Expl(t).X - 7, Expl(t).Y - 7), LExplodePics(100 * (-1 - Expl(t).p))
            ELSE
               'CheckPos t, 14
               PUT (Expl(t).X - 14, Expl(t).Y - 14), BExplodeMasks(394 * (-11 - Expl(t).p)), AND
               PUT (Expl(t).X - 14, Expl(t).Y - 14), BExplodePics(394 * (-11 - Expl(t).p))
            END IF
            Expl(t).p = Expl(t).p - 1
            IF IntScr = 11 AND (Expl(t).p = -5 OR Expl(t).p = -18) THEN Expl(t).p = 0
           
      END SELECT
   NEXT t

END IF

END SUB

SUB MoveStars (BGCol AS INTEGER, cud AS INTEGER) STATIC

FOR t = 1 TO NumStars
   IF Stars(t).Damage >= Stars(t).DY THEN
      IF Stars(t).g THEN PSET (Stars(t).X, Stars(t).Y), BGCol
      Stars(t).Y = Stars(t).Y + 1
      IF Stars(t).Y > 199 THEN
         NewStar t
      ELSE
         IF POINT(Stars(t).X, Stars(t).Y) <> BGCol THEN
            Stars(t).g = 0
         ELSE
            PSET (Stars(t).X, Stars(t).Y), Stars(t).p
            Stars(t).g = 1
         END IF
      END IF
      Stars(t).Damage = 1
   ELSE
      Stars(t).Damage = Stars(t).Damage + 1
      t2 = POINT(Stars(t).X, Stars(t).Y)
      IF cud THEN
         IF t2 <> BGCol AND t2 <> Stars(t).p THEN
            Stars(t).g = 0
         ELSE
            PSET (Stars(t).X, Stars(t).Y), Stars(t).p
            Stars(t).g = 1
         END IF
      END IF
   END IF
NEXT t


END SUB

SUB MoveStars2 STATIC

FOR t = 1 TO NumStars
   t2 = POINT(Stars(t).X, Stars(t).Y)
   IF IntScr = 5 THEN
      IF t2 <= 127 AND t2 >= 112 THEN PRESET (Stars(t).X, Stars(t).Y)
   ELSEIF IntScr = 12 THEN
      IF (t2 >= 160 AND t2 <= 191) OR t2 >= 240 THEN PRESET (Stars(t).X, Stars(t).Y)
   ELSE
      IF t2 >= 240 THEN PRESET (Stars(t).X, Stars(t).Y)
   END IF
   Stars(t).X = Stars(t).X + Stars(t).DX
   Stars(t).Y = Stars(t).Y + Stars(t).DY
   IF POINT(Stars(t).X, Stars(t).Y) = 0 THEN PSET (Stars(t).X, Stars(t).Y), Stars(t).p
   IF Stars(t).X > 319 OR Stars(t).X < 0 OR Stars(t).Y > 199 OR Stars(t).Y < 0 THEN
      SELECT CASE IntScr
         CASE 1
            IF RND > .385 THEN
               Stars(t).X = INT(RND * 320)
               Stars(t).Y = 1
            ELSE
               Stars(t).X = 1
               Stars(t).Y = INT(RND * 200)
            END IF
            Stars(t).p = INT(RND * 16 + 240)
            t2 = INT(RND * 4 + 1)
            t2 = 4
            Stars(t).DX = 2 * t2
            Stars(t).DY = t2
         CASE 2, IS < 0
            Stars(t).X = INT(RND * 320)
            Stars(t).Y = 1
            Stars(t).p = INT(RND * 16 + 240)
            t2 = INT(RND * 3 + 1)
            Stars(t).DX = 0
            Stars(t).DY = 12 '6 * t2
            IF IntScr < 0 THEN Stars(t).DY = t2 * -IntScr
         CASE 3
            Stars(t).X = 1
            Stars(t).Y = INT(RND * 200)
            Stars(t).p = INT(RND * 16 + 240)
            t2 = INT(RND * 2)
            Stars(t).DX = 9 + t2
            Stars(t).DY = 0
         CASE 4
            Stars(t).X = INT(RND * 320)
            Stars(t).Y = INT(RND * 200)
            Stars(t).p = INT(RND * 16 + 240)
            Stars(t).DX = 9 + (Stars(t).X - 160) \ 5
            Stars(t).DY = (Stars(t).Y - 100) \ 5
         CASE 5
            Stars(t).X = INT(RND * 320)
            Stars(t).Y = 0
            Stars(t).p = INT(RND * 12 + 112)
            Stars(t).DX = INT(RND * 3 - 1)
            Stars(t).DY = INT(RND * 5 + 10)
         CASE 10
            IF INT(RND * 8) = 0 THEN
               Stars(t).X = 0
               Stars(t).Y = INT(RND * 200)
            ELSE
               Stars(t).X = INT(RND * 320)
               Stars(t).Y = 199
            END IF
            Stars(t).p = INT(RND * 16 + 240)
            Stars(t).DX = 1
            Stars(t).DY = -INT(RND * 2) - 3
         CASE 12
            IF t <= 100 THEN
               Stars(t).X = 0
               Stars(t).Y = INT(RND * 200)
               Stars(t).p = INT(RND * 16 + 240)
               Stars(t).DX = 1
               Stars(t).DY = 0
            END IF
            '   Stars(t).X = 319: Stars(t).Y = 199: Stars(t).p = 0: Stars(t).DX = 0: Stars(t).DY = 0
            'END IF
      END SELECT
   END IF
NEXT t


END SUB

SUB NewExpl (X AS INTEGER, Y AS INTEGER, S AS INTEGER, t AS INTEGER, u AS INTEGER)

FOR t2 = 1 TO MaxExpl
   IF Expl(t2).p = 0 THEN EXIT FOR
NEXT t2
IF t2 < MaxExpl THEN
   r = t * 3 - 70
   Expl(t2).X = X + r / 2 - INT(RND * (r + 1))
   Expl(t2).Y = Y + r / 2 - INT(RND * (r + 1))
   IF u = 0 THEN
      Expl(t2).DX = INT(RND * 5 - 2) + (Expl(t2).X - X) \ 5
      Expl(t2).DY = INT(RND * 5 - 2) + (Expl(t2).Y - Y) \ 5
   ELSE
      Expl(t2).DX = -(IntScr = 12)
      Expl(t2).DY = 0
   END IF
   IF S = 1 THEN Expl(t2).p = -11 ELSE Expl(t2).p = -1
ELSE

END IF

END SUB

SUB NewStar (n AS INTEGER) STATIC
   Stars(n).X = INT(RND * 320)
   Stars(n).Y = 0
   Stars(n).DY = INT(RND * 11 + 2) \ 2
   IF IntScr = 4 THEN
      Stars(n).p = INT(RND * 12) + 240
   ELSEIF IntScr = 0 THEN
      Stars(n).p = INT(RND * 12) + 32
   ELSE
      Stars(n).p = INT(RND * 12) + 112
   END IF
END SUB

SUB RotateFontPal (Batch AS INTEGER) STATIC

c1 = Batch * 4 + 1: c2 = c1 + 3
FontPC(Batch) = FontPC(Batch) MOD 20 + 1
REDIM Temp(c1 TO c2) AS Colour
FOR t = c1 TO c2
   Temp(t).Red = FontCol(Batch).Red * FontPal(FontPC(Batch), t - Batch * 4)
   Temp(t).Green = FontCol(Batch).Green * FontPal(FontPC(Batch), t - Batch * 4)
   Temp(t).Blue = FontCol(Batch).Blue * FontPal(FontPC(Batch), t - Batch * 4)
NEXT t
SetPalette Temp(), c1, c2

END SUB

SUB SetLocks (n AS INTEGER) STATIC


DEF SEG = 0
SELECT CASE n
   CASE 1
      IF OldLocks = 0 THEN OldLocks = PEEK(&H417)
      POKE &H417, OldLocks AND (NOT &H70)
   CASE ELSE
      POKE &H417, OldLocks
END SELECT
DEF SEG


END SUB

SUB SetPalette (PalArray() AS Colour, c1 AS INTEGER, c2 AS INTEGER) STATIC

DEF SEG : OUT &H3C8, c1
FOR t = c1 TO c2
   OUT &H3C9, PalArray(t).Red
   OUT &H3C9, PalArray(t).Green
   OUT &H3C9, PalArray(t).Blue
NEXT t

END SUB

SUB Text (Batch AS INTEGER, x1 AS INTEGER, y1 AS INTEGER, x2 AS INTEGER, y2 AS INTEGER, Message AS STRING, Col AS INTEGER) STATIC

DIM FontCol2 AS Colour
FontCol2.Red = Col AND 1
FontCol2.Green = (Col AND 2) \ 2
FontCol2.Blue = (Col AND 4) \ 4

c1 = Batch * 4 + 1: c2 = c1 + 3

IF (FontCol(Batch).Red <> FontCol2.Red OR FontCol(Batch).Green <> FontCol2.Green OR FontCol(Batch).Blue <> FontCol2.Blue) THEN
   FontCol(Batch) = FontCol2
   REDIM Temp(c1 TO c2) AS Colour
   FOR t = c1 TO c2
      Temp(t).Red = FontCol(Batch).Red * FontPal(FontPC(Batch), t - Batch * 4)
      Temp(t).Green = FontCol(Batch).Green * FontPal(FontPC(Batch), t - Batch * 4)
      Temp(t).Blue = FontCol(Batch).Blue * FontPal(FontPC(Batch), t - Batch * 4)
   NEXT t
   SetPalette Temp(), c1, c2
END IF

IF x2 = 0 THEN x2 = 319
IF y2 = 0 THEN y2 = 199
x2 = x2 - 7: y2 = y2 - 7
X = x1: Y = y1

REDIM WordLen(100) AS INTEGER
WordPos = 1

FOR t = 1 TO LEN(Message)
   A = ASC(MID$(Message, t, 1)) - 32
   IF A >= 1 AND A <= 95 THEN
      WordLen(WordPos) = WordLen(WordPos) + FontWidth(A) + 2
   ELSEIF A = 0 THEN
      WordPos = WordPos + 1
   END IF
NEXT t

WordPos = 1
FOR t = 1 TO LEN(Message)
   A = ASC(MID$(Message, t, 1)) - 32
   IF A >= 0 AND A <= 95 THEN
      PUT (X, Y), FontPics(A * 34 + Batch * 3264), PSET
      X = X + FontWidth(A) + 2
   END IF
   IF A = 0 THEN
      WordPos = WordPos + 1
      IF x2 - X < WordLen(WordPos) THEN
         Y = Y + 8: X = x1
         IF Y > y2 THEN STOP
      END IF
   END IF
NEXT t

END SUB

SUB TitlePal STATIC

   PC = (PC + 1) MOD 128

   OUT &H3C8, 64
   FOR t = 64 TO 127
      OUT &H3C9, Pal(t + PC).Red
      OUT &H3C9, Pal(t + PC).Green
      OUT &H3C9, Pal(t + PC).Blue
   NEXT t

END SUB

FUNCTION TitleScreen 'STATIC

DIM TitlePic(9151) AS INTEGER
DEF SEG = VARSEG(TitlePic(0)): BLOAD "title.pic", VARPTR(TitlePic(0))
DEF SEG = VARSEG(Pal(0)): BLOAD "title.pal", VARPTR(Pal(0)): DEF SEG
PC = 64: TitlePal
IF Fl1 = 0 THEN PALETTE 31, 0

NumStars = 100: InitStars
DIM W$(0 TO 4), Wp(0 TO 4) AS INTEGER
W$(0) = "BEGIN MISSION"
W$(1) = "PRACTICE MODE"
W$(2) = " INSTRUCTIONS"
W$(3) = "    GAME INFO"
W$(4) = "        QUIT"
Wp(0) = 1: Wp(1) = -1: Wp(2) = -1: Wp(3) = -3: Wp(4) = -2

LINE (0, 0)-(319, 199), 31, BF
'PALETTE 0, 0
LINE (93, 96)-(228, 150), 0, BF

PUT (38, 20), TitlePic(0), PSET

FOR t = -3 TO 3
   LINE (93 + t, 96 + t)-(228 - t, 150 - t), 32 + ABS(t) * 3 + 5, B
NEXT t

'Text 0, 114, 40, 0, 0, "(insert title here)", 3
FOR t = 0 TO 4
   Text 0, 107 + Wp(t), 104 + t * 8, 0, 0, W$(t), 3
NEXT t
Text 2, 110, 172, 0, 0, "David Karlov 1998", 4

y1 = 101: ty1 = 102: oy1 = 0: C = 0

DO
   OP = PEEK(284): DEF SEG
   C = C + 1
   i$ = INKEY$
   SELECT CASE UCASE$(i$)
      CASE CHR$(0) + "H"
         ty1 = ty1 - 8: IF ty1 < 102 THEN ty1 = 134
      CASE CHR$(0) + "P"
         ty1 = ty1 + 8: IF ty1 > 134 THEN ty1 = 102
      CASE CHR$(13), " "
         SELECT CASE ty1
            CASE 102
               TitleScreen = 0: EXIT FUNCTION
            CASE 110
               TitleScreen = 1: EXIT FUNCTION
            CASE 118
               TitleScreen = 2: EXIT FUNCTION
            CASE 126
               TitleScreen = 3: EXIT FUNCTION
            CASE 134
               CYaL8r
         END SELECT
      CASE CHR$(27)
         CYaL8r
'      CASE "S"
'         SND = 1 - SND
'         ''''''''''''''''''''''''''''''''
   END SELECT
   IF i$ <> "" THEN C = C MOD 6


   IF ty1 <> oy1 THEN
      IF oy1 > 0 THEN Text 0, 107 + Wp((oy1 - 102) / 8), oy1 + 2, 0, 0, W$((oy1 - 102) / 8), 3
      Text 1, 107 + Wp((ty1 - 102) / 8), ty1 + 2, 0, 0, W$((ty1 - 102) / 8), 2
      oy1 = ty1
   END IF
  
   IF ty1 <> y1 THEN
      LINE (98, y1 + 2)-(105, y1 + 9), 0, BF
      LINE (217, y1 + 2)-(224, y1 + 9), 0, BF
      y1 = y1 + SGN(ty1 - y1) * SQR(ABS(ty1 - y1))
      Text 1, 98, y1 + 2, 0, 0, ">", 2
      Text 1, 217, y1 + 2, 0, 0, "<", 2
   END IF
  
     
   MoveStars 31, 0

   TitlePal

   RotateFontPal 1
   IF C MOD 2 THEN RotateFontPal 0
   IF C MOD 3 = 0 THEN RotateFontPal 2

   IF Fl1 < 0 THEN
      PALETTE 0, Int3Pal(Fl1 + 13)
      PALETTE 31, Int3Pal(Fl1 + 13)
      Fl1 = Fl1 + 1
   END IF

   DEF SEG = 53
   DO: LOOP UNTIL PEEK(284) <> OP
   IF C >= 300 THEN TitleScreen = -1: EXIT FUNCTION
LOOP

END FUNCTION

SUB VPutDBL (x1 AS INTEGER, y1 AS INTEGER, A() AS DOUBLE, el AS LONG, Mode, MinY AS INTEGER, MaxY AS INTEGER)

IF MinY > MaxY THEN SWAP MinY, MaxY
IF MinY < 0 THEN MinY = 0
IF MaxY > 199 THEN MaxY = 199

DIM SizeData AS STRING * 8
DIM NewPosWord AS STRING * 8
DIM XSize AS INTEGER, YSize AS INTEGER
DIM NewEl AS INTEGER, Newy1 AS INTEGER
DIM NewYSize AS INTEGER

SizeData = MKD$(A(el))

XSize = (ASC(MID$(SizeData, 1, 1)) + 256 * ASC(MID$(SizeData, 2, 1))) \ 8
YSize = ASC(MID$(SizeData, 3, 1)) + 256 * ASC(MID$(SizeData, 4, 1))

IF y1 < MinY THEN
   NewYSize = y1 + YSize - MinY
   IF NewYSize <= MinY THEN EXIT SUB
   MID$(SizeData, 3, 2) = MKI$(NewYSize)
   NewEl = el - (XSize \ 8) * (y1 - MinY)
   NewPosWord = MKD$(A(NewEl))
   Newy1 = MinY
   MID$(SizeData, 5, 4) = MID$(NewPosWord, 5, 4)
   A(NewEl) = CVD(SizeData)
ELSE
   NewEl = el
   NewYSize = YSize
   Newy1 = y1
   NewPosWord = MKD$(A(NewEl))
END IF


yExtra = Newy1 + NewYSize - MaxY - 1
IF yExtra > 0 THEN
   SizeData = MKD$(A(NewEl))
   NewYSize = NewYSize - yExtra
   IF NewYSize <= 0 THEN EXIT SUB
   MID$(SizeData, 3, 2) = MKI$(NewYSize)
   A(NewEl) = CVD(SizeData)
END IF

SELECT CASE Mode
   CASE 1
      PUT (x1, Newy1), A(NewEl), PSET
   CASE 2
      PUT (x1, Newy1), A(NewEl), PRESET
   CASE 3
      PUT (x1, Newy1), A(NewEl), AND
   CASE 4
      PUT (x1, Newy1), A(NewEl), OR
   CASE ELSE
      PUT (x1, Newy1), A(NewEl), XOR
END SELECT


A(NewEl) = CVD(NewPosWord)



END SUB

